/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : ImgProcess.h
* Author             : AST Robotics group
* Date First Issued  : 11 October 2007 : Version 1.0
* Description        : header for ImgProcess.c.
********************************************************************************
* History:
* 11 October 2007 : Version 1.0
*******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef _RGB_CUBE_H_
#define _RGB_CUBE_H_

/* Includes ------------------------------------------------------------------*/
#include "utils.h"

//#define RGBCube_MACRO

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Module private variables --------------------------------------------------*/
extern u8 *pRGBCubeData;
#ifdef RGBCube_MACRO
	extern u8 RGBCubeData[16][16][16];
#endif
/* Exported macro ------------------------------------------------------------*/
#ifdef RGBCube_MACRO
	#define RGB565_GetR4(Pixel16) (((Pixel16)>>12)&0x0F)
	#define RGB565_GetG4(Pixel16) (((Pixel16)>>7)&0x0F)
	#define RGB565_GetB4(Pixel16) (((Pixel16)>>1)&0x0F)
	#define RGBCube_GetValue(r,g,b) (RGBCubeData[(r)][(g)][(b)])
	#define RGBCube_SetValue(r,g,b, Value) (RGBCubeData[(r)][(g)][(b)]=(Value))
	#define RGBCube_CheckValue(r,g,b, Value) (RGBCubeData[(r)][(g)][(b)]==(Value))
	#define RGBCube_TestPixel_565(Pixel16, IDCol) RGBCube_CheckValue(RGB565_GetR4(Pixel16), RGB565_GetG4(Pixel16), RGB565_GetB4(Pixel16), IDCol)
	#define RGBCube_GetValue_565(Pixel16) RGBCube_GetValue(RGB565_GetR4(Pixel16), RGB565_GetG4(Pixel16), RGB565_GetB4(Pixel16))
#endif
/* Private functions ---------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
#ifndef RGBCube_MACRO
	int RGB565_GetR4(u16 Pixel16);
	int RGB565_GetG4(u16 Pixel16);
	int RGB565_GetB4(u16 Pixel16);
	void RGBCubeCol_Clear(int r, int g, int b);
	void RGBCubeCol_AddMask(int r, int g, int b, u8 IDMask);
	void RGBCubeCol_ClearMask(int r, int g, int b, u8 IDMask);
	int RGBCubeCol_CheckMask(int r, int g, int b, u8 IDMask);
	int RGBCubeCol565_CheckMask(u16 Pixel16, u8 IDMask);
#endif

void RGBCube_Clear(void);
int RGBCube_GetID_Num(void);
void RGBCube_AddCube(u8 RMin, u8 RMax, u8 GMin, u8 GMax, u8 BMin, u8 BMax, u8 IDCol);
void RGBCube_SubCube(u8 RMin, u8 RMax, u8 GMin, u8 GMax, u8 BMin, u8 BMax, u8 IDCol);
void RGBCube_AddRed(u8 RGMin, u8 RBMin, u8 IDCol);
void RGBCube_AddBlue(u8 BRMin, u8 BGMin, u8 IDCol);
void RGBCube_AddGreen(u8 GRMin, u8 GBMin, u8 IDCol);
void RGBCube_AddCubeYCbCr(u8 YMin, u8 YMax, u8 CbMin, u8 CbMax, u8 CrMin, u8 CrMax, u8 IDCol);
void RGBCube_SubCubeYCbCr(u8 YMin, u8 YMax, u8 CbMin, u8 CbMax, u8 CrMin, u8 CrMax, u8 IDCol);

s32 FindCentroid(u8 *pBuffer, u16 ResW, u16 ResH, u32 *OutX, u32 *OutY, u8 IDCol);

#endif /* _RGB_CUBE_H_ */


/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/

