/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : TMatrix.h
* Author             : AST Robotics group 
* Date First Issued  : 17 August 2009 : Version 1.0
* Description        : header for TMatrix.c.
********************************************************************************
* History:
* 17 August 2009 : Version 1.0
*******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __TMATRIX_H__
#define __TMATRIX_H__

/* Includes ------------------------------------------------------------------*/
#include "91x_lib.h"
#include "TMatrix.h"

/* Exported types ------------------------------------------------------------*/

typedef struct {
  void **Matrix;
  u8 Row, Col;
} TMatrix;

typedef struct {
  s8 **Matrix;
  u8 Row, Col;
} TMatrixS8;

typedef struct {
  u8 **Matrix;
  u8 Row, Col;
} TMatrixU8;

typedef struct {
  s16 **Matrix;
  u8 Row, Col;
} TMatrixS16;

typedef struct {
  s32 **Matrix;
  u8 Row, Col;
} TMatrixS32;

/* Exported constants --------------------------------------------------------*/
/* Module private variables --------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

void MatrixInit(TMatrix *Mat, void *Data, void **RowPointers, u8 r, u8 c, u8 CellSize);
void MatShiftRowUp(TMatrix *Mat);

bool MatConv_mS32_kS8_oS32(TMatrixS32 *Mat, TMatrixS8 *Kern, TMatrixS32 *Out);
bool MatConv_mS32_kS8_oS32_1Row(TMatrixS32 *Mat, TMatrixS8 *Kern, TMatrixS32 *Out, u32 MatRow, u32 OutRow);
bool MatConv_mU8_kS8_oS32(TMatrixU8 *Mat, TMatrixS8 *Kern, TMatrixS32 *Out);
bool MatConv_mU8_kS8_oS32_1Row(TMatrixU8 *Mat, TMatrixS8 *Kern, TMatrixS32 *Out, u32 MatRow, u32 OutRow);
void VectOrdFilter(TMatrixS32 *Mat, s32 *LM1, s32 *LM2);
void MatOrdFilter(TMatrixS32 *Mat, TMatrixS32 *LM1, TMatrixS32 *LM2, u32 ColLen);
void MatOrdFilter_LastRow(TMatrixS32 *Mat, TMatrixS32 *LM1, TMatrixS32 *LM2, u32 ColLen);

#endif /* __TMATRIX_H__ */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/

/*typedef struct TMatrix{
	double **Matrix;	//Puntatore alla matrice
	int Row, Col; 		// Numero di righe e di Colonne
} TMatrix;

typedef TMatrix *PMatrix;

TMatrix *AllocMatr(int R, int C);
// Alloca lo spazio per la struttura

void DeallocMatr(TMatrix **M);
// Dealloca lo spazio per la struttura

int IsSquareMatr(TMatrix *M);
// Verifica se la matrice M  quadrata
// Ritorna 1 se lo ; 0 altrimenti;

TMatrix *DotMatr(TMatrix *M1, TMatrix *M2);
// Restituisce il puntatore alla matrice prodotto

TMatrix *AddMatr(TMatrix *M1, TMatrix *M2);
// Somma M1 ed M2 e restituisce il puntatore alla matrice somma
// Restituisce 0 se non  possibile sommare

TMatrix *NegMatr(TMatrix *M);
// Restituisce un puntatore alla negata della matrice

TMatrix *ScalarDotMatr(TMatrix *M, double d);
// Restituisce un puntatore alla matrice prodotto d*M

TMatrix *TraspMatr(TMatrix *M);
// Restituisce un puntatore alla trasposta della matrice

TMatrix *InvMatr(TMatrix *M);
// Restituisce la matrice inversa di M

TMatrix *IdentityMatr(int r);
// Restituisce una Matrice identit di dimensione rxr;

TMatrix *SmallFilter(TMatrix *M, double Epsilon);
// Azzera i valori inferiori ad Epsilon

void ViewMatr(TMatrix *M,int T);
// Visualizza M

TMatrix *CopyMatr(TMatrix *M);
// Restituisce una copia della matrice

TMatrix *EditMatr(int Row, int Col);
// Ritorna la matrice digitata con la tastiera

TMatrix *lu_dec(TMatrix indx, TMatrix *M, int d);
void CopyColonna(TMatrix *toM,TMatrix *fromM, int fromCol, int toCol);
void LU_back_subst(TMatrix *indx, TMatrix  *b,TMatrix *decomp);
TMatrix *scale(TMatrix *Aux);
void switch_columns(TMatrix *M, int col1, int col2);
TMatrix *LU_dec(TMatrix *indx,TMatrix *decomp);*/

