/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: c4mMem.h.rca 1.2 Wed Jul 23 10:40:01 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: c4mMem.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:40:01 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:56 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

/*******************************************************************************
 * CVS Id    $Id: c4mMem.h.rca 1.2 Wed Jul 23 10:40:01 2008 vitor.schwambach@st.com Experimental $
 *
 * File:     c4mMem.h
 *
 * Author:   Luigi Arnone, Luca Petrelli.
 *
 * eMail:    luigi.arnone@st.com  
 *
 * Org:      Agrate Advanced System Technologies lab.
 *           STMicroelectronics S.r.l.
 *           Politecnico di Milano - WOWS!Lab
 *
 * Created:  2005-08-28
 *
 * Modified: 2005-08-28
 *
 * Purpose:  
 *
 * COPYRIGHT:
 * This program is property of Agrate Advanced System Technology
 * lab, from STMicroelectronics S.r.l. and WOWS!Lab Politecnico di Milano
 ******************************************************************************/

#ifndef __C4MMEM_H_
#define __C4MMEM_H_

#ifndef __C4MTYPES_H_
#include "c4mTypes.h"
#endif

#include "stcmalloc.h"
//#include "memory.h"

#include <stdlib.h>
#include <string.h> //memcpy needed 
#ifdef __cplusplus
extern "C" {
#endif

#define C4M_MEM_ALIGN(s)	(((((int32)(s) - 3) >> 2) + 1) << 2)

typedef struct _c4mMem {
	void *p;
	void *pinit;
	void *pend;
} c4mMem;

/* Copies characters between buffers. */
C4M_INLINE void* c4mMemCopy(void *dest, const void *src, size_t count) { return memcpy(dest, src, count); } 

/* Creates a new buffer. */
C4M_INLINE void* c4mMemMalloc(const uint32 size) { return xmalloc(size); }

/* Creates a new buffer. */
//C4M_INLINE void* c4mMemCalloc(const uint32 items, const uint32 size) { return calloc(items, size); }

/* Deallocates or frees a memory block. */
C4M_INLINE void c4mMemFree(void* data) { xfree(data); }

int8 c4mMemInit(c4mMem *mem, uint32 size, void *pdata);
int8 c4mCreateMatrix(c4mMem *mem, c4mMatrix *mat, uint32 r, uint32 c, int16 esize);

/* memset re-definition. */
#define c4mMemset memset

#ifdef __cplusplus
}
#endif

#endif /* __C4MMEM_H_ */


