/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
 * File Name          : definitions.h
 * Author             : AST Robotics group
 * Date First Issued  : 11 May 2007 : Version 1.0
 * Description        : generic definitions and pin assignments file for Dongle.
 ********************************************************************************
 * History:
 * 28 May 2007 : Version 1.2
 * 11 May 2007 : Version 1.0
 *******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
 *******************************************************************************/

/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __DEFINITIONS_H
#define __DEFINITIONS_H

// *-------------*-------------*------------*
// | UART2_RxD   | N.A.        | UART2_RxD  |
// | UART2_TxD   | N.A.        | UART2_TxD  |
// | I2C_SCL     | P3.4        | SW_I2C_SCL |
// | I2C_SDA     | P3.5        | SW_I2C_SDA |
// | CAM_CE      | P3.6        | GPIO_OUT   |
// | CAM_PCLK    | P3.0        | Ext_Dma_In |
// | CAM_VSYNC   | P3.2        | EXT_INT_2  |
// | CAM_CLK_IN  | P3.7        | T1_PWM_OUT |
// | CAM_BUS     | P9.ALL      | GPIO_IN    |
// | LED_R       | P6.0        | GPIO_OUT   |
// | SW_1234     | P7.0123     | GPIO_IN    |
// | USB_Dp      | P7.5        | GPIO_OUT   |
// *-------------*-------------*------------*

//#define RVS_MB
#define STL_MB
//#define NO_DEBUG

#define PresentationStringConst "STLCam\nV:0.41\nAST-Robotics\nSTMicroelectronics\n"

#define TMsg_EOF     0xF0
#define TMsg_BS      0xF1
#define TMsg_BS_EOF  0xF2
#define TMsg_MaxLen  128

#define DEV_ADDR     0x32

#define USB_Dp_PullUp_GPIO GPIO0
#define USB_Dp_PullUp_GPIOx_Pin GPIO_Pin_1

#define Cam724
//IRQ Priority    // 0 Highest, 15 Lowest
//#define SERVO_TIM_ITPriority      0
//#define x24_DMA_ITPriority        1
//#define x24_VSYNC_INT_ITPriority  2
//#define x24_SYNC_TIM_IPriority    3
#define USB_Priority              5
/*
 #define MOTOR1_Priority			  9
 #define MOTOR2_Priority			  10
 #define MOTOR3_Priority			  11
 */

#ifdef STL_MB
#define LEDR_GPIO GPIO3
#define LEDR_GPIOx_Pin GPIO_Pin_7
#endif

#define DE_GPIO GPIO4
#define DE_GPIOx_Pin GPIO_Pin_3

#define x24_VSYNC_GPIO GPIO7
#define x24_VSYNC_GPIOx_Pin GPIO_Pin_7
#define x24_VSYNC_INT_WIU_Line ((u32)WIU_Line31)
#define x24_VSYNC_INT_WIU_Line_N 31
#define x24_VSYNC_INT_ITx_LINE EXTIT3_ITLine

#define MY_GPIO GPIO3
#define MY_GPIOx_Pin GPIO_Pin_2
#define MY MY_GPIO->DR[MY_GPIOx_Pin<<2]
#define MY_ON() MY=0xFF
#define MY_OFF() MY=0x00

#define LEDR LEDR_GPIO->DR[LEDR_GPIOx_Pin<<2]
#define USB_Dp_PullUp USB_Dp_PullUp_GPIO->DR[USB_Dp_PullUp_GPIOx_Pin<<2]

#define DE DE_GPIO->DR[DE_GPIOx_Pin<<2]

#define LED_ON(Led) Led=0xFF;
#define LED_OFF(Led) Led=0x00;
#define LED_TOGGLE(Led) Led=~Led;
#define DE_ON(De) De=0xFF;
#define DE_OFF(De) De=0x00;
#define IS_BTN_PRESSED(Btn) (Btn==0)
#define WAIT_BTN(Btn) { while(!IS_BTN_PRESSED(Btn)); while(IS_BTN_PRESSED(Btn));}
#define USB_Dp_PullUp_OFF(); USB_Dp_PullUp=0xFF;
#define USB_Dp_PullUp_ON(); USB_Dp_PullUp=0x00;

//define motor direction
#define FORWARD 1
#define REVERSE 0

//define servo position
#define SERVO_TOP 0
#define SERVO_MID 1
#define SERVO_BOTTOM 2
#define STOP_SERVO 1
// the servo pins on micro
#define SERVO_GPIO				GPIO1
#define SERVO_Pin				GPIO_Pin_1
//motor pins
#define NUM_MOTORS				3
#define MOTOR_GPIO				GPIO1
#define MOTOR1_Pin				GPIO_Pin_6
#define MOTOR2_Pin				GPIO_Pin_4
#define MOTOR3_Pin				GPIO_Pin_3
#define MOTOR_DIRECTION_GPIO	GPIO0
//X for the first input which is INA
#define MOTOR1_DIRECTION_A		GPIO_Pin_4
#define MOTOR1_DIRECTION_B		GPIO_Pin_5
#define MOTOR2_DIRECTION_A		GPIO_Pin_2
#define MOTOR2_DIRECTION_B		GPIO_Pin_3
#define MOTOR3_DIRECTION_A		GPIO_Pin_6
#define MOTOR3_DIRECTION_B		GPIO_Pin_7

//bumper pins
#define BUMPER1 				GPIO5
#define BUMPER2					GPIO0
#define BUMPER3					GPIO4
#define BUMPER_FRONT_LEFT				GPIO_Pin_2 //5.2
#define BUMPER_FRONT_RIGHT				GPIO_Pin_0 //4.0
#define BUMPER_BACK_LEFT				GPIO_Pin_7 //1.7
#define BUMPER_BACK_RIGHT				GPIO_Pin_1 //4.1
#define BUMPER_RIGHT	 				GPIO_Pin_3 //5.5
#define BUMPER_LEFT						GPIO_Pin_0 //1.0
#define LEFT 					1
#define RIGHT					0

#define CLOSE					8
#define NORMAL					4
#define FAR					    2

#endif

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
