/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : utils.h
* Author             : AST Robotics group 
* Date First Issued  : 11 May 2007 : Version 1.0
* Description        : header fo utils.c.
********************************************************************************
* History:
* 28 May 2007 : Version 1.2
* 11 May 2007 : Version 1.0
*******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __UTILS_H
#define __UTILS_H

/* Includes ------------------------------------------------------------------*/
#include "91x_lib.h"

/* Exported types ------------------------------------------------------------*/

//typedef s32 Bool;

/* Exported constants --------------------------------------------------------*/
/* Module private variables --------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/

#define SaturaLH(N, L, H) (((N)<(L))?(L):(((N)>(H))?(H):(N)))
#define SaturaL(N, L) (((N)<(L))?(L):(N))
#define SaturaH(N, H) (((N)>(H))?(H):(N))
#define Abs(a) (((a)>=0)?(a):-(a))
#define Sign(a) (((a)>=0)?1:-1)

/* Private functions ---------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

void uDelay(u32 nCount);
void MSDelay(u32 nCount);
void UART_SendByte(UART_TypeDef* UARTx, u8 Data);
void UART_SendString(UART_TypeDef* UARTx, u8 *String);
void UART_SendBuffer(UART_TypeDef* UARTx, u8 *pBuf, u16 Len);
void UART_SendBufferASHII(UART_TypeDef* UARTx, u8 *pBuf, u16 Len);

void Num2String(int Num, u8 *String);
u8 u4toAshii(u8 ch);
void u8toDoubleAshii(u8 ch, u8 *Ashii);
void u16toQuadAshii(u16 i, u8 *Ashii);
void u32toOctAshii(u32 i, u8 *Ashii);
u32 Ashii_to_Unsigned(u8 *Ashii, u8 N);
u32 StrLen(u8 *Str);

#endif /* __UTILS_H */

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
