/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : usb_endp.c
* Author             : MCD Application Team
* Date First Issued  : 10/01/2006 : V1.0
* Description        : Endpoint routines
********************************************************************************
* History:
* 10/01/2006 : V1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/
/* Includes ------------------------------------------------------------------*/
#include "usb_lib.h"
#include "usb_desc.h"
#include "usb_config.h"
#include "fifo.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
u8 USB_RxFifoBuffer[USB_RxFifoDim];
TCharFifo USB_RxFifo;
//u8 USB_buffer_in[VIRTUAL_COM_PORT_DATA_SIZE];
//u32 USB_count_in = 0;
volatile u8 USB_FlagTxProcess = 0;
u8 USB_FlagRxBytes=0;
u8 USB_FlagRxErr=0;
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void USB_endPointConf(void)
{
  CharFifo_Init(&USB_RxFifo, USB_RxFifoDim, USB_RxFifoBuffer);
}

void USB_WriteBuffer_1(u8 *pBuffer, u8 Len)
{
  while (USB_FlagTxProcess);
  USB_FlagTxProcess=1;
  UserToPMABufferCopy(pBuffer, ENDP1_TXADDR, Len);
  SetEPTxCount(ENDP1, Len);
  SetEPTxValid(ENDP1);
}

void USB_WriteBufferAshii_1(u8 *pBuffer, u8 Len)
{
  while (USB_FlagTxProcess);
  USB_FlagTxProcess=1;
  UserToPMABufferCopyAshii(pBuffer, ENDP1_TXADDR, Len);
  Len<<=1;
  SetEPTxCount(ENDP1, Len);
  SetEPTxValid(ENDP1);
}

//extern void MSDelay(u32 nCount);

void USB_WriteBuffer(u8 *pBuffer, u32 Len)
{
  u8 a;
  
  while (Len>0) {
    a=(Len>60)?60:Len;
    USB_WriteBuffer_1(pBuffer, a);
//    MSDelay(1);
    Len-=a;
    pBuffer+=a;
  }
}

void USB_WriteBufferAshii(u8 *pBuffer, u32 Len)
{
  u32 a;
  
  while (Len>0) {
    a=(Len>30)?30:Len;
    USB_WriteBufferAshii_1(pBuffer, a);
//    MSDelay(1);
    Len-=a;
    pBuffer+=a;
  }
}

void USB_WriteString(u8 *pString)
{
  u32 Len=0;
  
  while (pString[Len]) Len++;
  USB_WriteBuffer(pString, Len+1);
}

/*******************************************************************************
* Function Name  : EP3_OUT_Callback
* Description    :
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP3_OUT_Callback(void)
{
  u32 CountNew, App;
  u8 *pData;
  
  CountNew = GetEPRxCount(ENDP3);
  if (CountNew) {
    USB_FlagRxBytes=1;
  }
  App=CharFifo_GetFree(&USB_RxFifo);
  if (CountNew > App) {
    CountNew=App; // some bytes are lost
    USB_FlagRxErr=1;
  }
  pData=PMAGetPointer(ENDP3_RXADDR);
  CharFifo_MultipleInsert(&USB_RxFifo, pData, CountNew);
  SetEPRxValid(ENDP3);
//  u32 CountNew, App;
//  CountNew = GetEPRxCount(ENDP3);
//  if (CountNew) {
//    USB_FlagRxBytes=1;
//  }
//  App=USB_count_in+CountNew;
//  if (App>VIRTUAL_COM_PORT_DATA_SIZE) {
//    CountNew-=App-VIRTUAL_COM_PORT_DATA_SIZE; // some bytes may be lost
//    USB_FlagRxErr=1;
//  }
//  PMAToUserBufferCopy(&USB_buffer_in[USB_count_in], ENDP3_RXADDR, CountNew);
//  USB_count_in+=CountNew;
//  SetEPRxValid(ENDP3);
}
/*******************************************************************************
* Function Name  : EP1_IN_Callback
* Description    :
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP1_IN_Callback(void)
{
  USB_FlagTxProcess = 0;
}
/******************* (C) COPYRIGHT 2006 STMicroelectronics *****END OF FILE****/


